#!/usr/bin/make -f
# Sous-système de messages pour le Makefile.
# Cinq dollars par message uniquement. En ce moment, promotion : pour sept
# messages affichés, trois messages offerts. Alors profitez-en !

# ---
# Couleurs et divers utilitaires.
# ---

# Modifiers ANSI pour les séquences d'échappement concernant les couleurs
# utilisées ci-dessous.

 color_green := 32
 color_red := 31
 color_yellow := 33

# Retour à la ligne. Peut venir à bout de situations où le tirage de cheveux
# est de mise.

define \n


endef

# ---
# “Who you're gonna call?”
# Ces fonctions-là, qui sont derrière les autres.
# ---

# Message de commande — affiche diverses informations basiques concernant
# la commande, avant de l'exécuter.

define _cmd
@$(if $(MAKE_FULL_LOG),,\
printf "\033[1;""$4""m>\033[0m \033[1m%s\033[0m %s\n" "$1" "$2";)
	$(if $(MAKE_FULL_LOG),,@)$3
endef

# Commande silencieuse — à rendre bavarde si le logging complet est activé.

define qcmd
$(if $(MAKE_FULL_LOG),,@)$1
endef

# Message normal — à afficher tel quel.

define _msg
$(if $(MAKE_FULL_LOG),,\
@printf "\033[1;""$2""m>\033[0m \033[1m%s\033[0m\n" "$1")
endef

# ---
# Commandes.
# ---

# Commandes de construction.

define bcmd
$(call _cmd,$1,$2,$3,$(color_green))
endef

# ---
# Messages.
# ---

# Message normal/générique.

define msg
$(call _msg,$1,$(color_green))
endef

# Message de suppression (en rouge).

define rmsg
$(call _msg,$1,$(color_red))
endef

# Message d'installation (en jaune).

define imsg
$(call _msg,$1,$(color_yellow))
endef

# End of file
